#ifndef SUSIEARCHIVEERAPPER
#define SUSIEARCHIVEERAPPER

#include "SusieWrapper.h"
#include "FileInArchive.h"
#include "FileType.h"
#include "Unmanaged.h"
#include "ProgressCallback.h"
#using <mscorlib.dll>
#using <System.dll>

using namespace System;
using namespace System::IO;

namespace HongliangSoft {
  namespace Utilities {
    public __gc class SusieArchiveWrapper : public SusieWrapper {
    private :
      GetArchiveInfoHandler getArchiveInfoHandler;
      GetFileInfoHandler getFileInfoHandler;
      GetFileHandler getFileHandler;
      __property bool get_CanGetArchiveInfo() { return getArchiveInfoHandler != NULL; }
      __property bool get_CanGetFileInfo() { return getFileInfoHandler != NULL; }
      __property bool get_CanGetFile() { return getFileHandler != NULL; }
    private public :
      SusieArchiveWrapper(HMODULE module);
    protected :
      void Dispose(bool disposing);
    public :
      FileInArchive* GetFilesInArchive(String* filePath) __gc [];
      FileInArchive* GetFileInfo(String* filePath, String* archiveFile, bool caseSensitive);
      String* GetFileToFile(FileInArchive* fileInfo, String* outputDirectory);
      String* GetFileToFile(FileInArchive* fileInfo, String* outputDirectory, ProgressCallback* callback);
      Stream* GetFileToStream(FileInArchive* fileInfo);
      Stream* GetFileToStream(FileInArchive* fileInfo, ProgressCallback* callback);
    };
  }
}
#endif